#ifndef FRAMEBUFFER_H_
#define FRAMEBUFFER_H_

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <GL/glut.h>

#include "v3.h"
#include "phc.h"

class FrameBuffer : public Fl_Gl_Window {

public:
  int w, h;
  unsigned int *pix;
  float *zb;
  FrameBuffer(int u0, int v0, int w, int h);
  void SetGrid(int checkerSize, unsigned int colors[2]);
  void Set(unsigned int color);
  void SetDepth(float depth0);
  void Set(int u, int v, unsigned int color);
  void SetGuarded(int u, int v, unsigned int color);
  void draw();
  void DrawDiagonalCross(
    int u, int v, unsigned int color, int sizePix);
  int handle(int event) ;  
  void KeyboardHandle();
  void Draw3DSegment(V3 P0, V3 col0, V3 P1, V3 col1, PPC *ppc);
  void Draw2DSegment(V3 P0, V3 col0, V3 P1, V3 col1);
  void SetIfCloser(V3 P, V3 col);
};


#endif