#pragma once

#include "v3.h"
#include "M3x3.h"

class FrameBuffer;

class PPC {

public:

  V3 a, b, c, C;
  int w, h;
  float nearz, farz;
  M3x3 invcam;

  void UpdateInvCam();
  PPC(float hfov, int _w, int _h, float _nearz, float _farz);
  bool Project(V3 P, V3& projP);
  V3 GetPoint(float uf, float vf);
  V3 GetPoint(float uf, float vf, float z);
  V3 GetVD();
  void Translate(V3 trans);
  void Zoom(float frel);
  void Pan(float panAngle);
  void Tilt(float tiltAngle);
  void Roll(float rollAngle);
  float Getf();
  void Visualize(PPC *dv, FrameBuffer *fb);
  void PositionAndOrient(V3 newC, V3 newVD, V3 quasiUp);

};