#pragma once

#include "v3.h"
#include "M3x3.h"
#include "framebuffer.h"
#include "phc.h"

class TMesh {

  V3 *vertices, *projVertices;
  int verticesN;
  V3 *colors;
  unsigned int *connectivity;
  int trianglesN;
public:
  TMesh();
  void Load(char *fname);
  void RenderPoints(PPC *ppc, FrameBuffer *fb);
  V3 GetCenter();
  void Translate(V3 trans);
  void Scale(float scf);
  BBox ComputeBBox();
  void PlaceAndScale(V3 newCenter, float bboxDiag);
  void Render(PPC *ppc, FrameBuffer *fb);
  M3x3 ComputeBarycentricInverse(V3 pvs[3]);
  M3x3 ComputeSSI(V3 pvs[3]);
  void Project(PPC *ppc);

};